unit m3801;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Spin, m3802;

type
  PSlovo = ^TSlovo;
  TSlovo = record
   Slovo:string[30];
   {Prev,}Next:PSlovo;
  end;

  TZaklOkno = class(TForm)
    TlacSpust: TButton;
    KecNacitam: TLabel;
    KecPocet: TLabel;
    ZadejVstup: TEdit;
    KecVstup: TLabel;
    KecVystup: TLabel;
    ZadejVystup: TEdit;
    OtevriSoubor: TOpenDialog;
    TlacHledejIn: TButton;
    TlacHledejOut: TButton;
    procedure TlacSpustClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure TlacHledejInClick(Sender: TObject);
    procedure TlacHledejOutClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    Slovnik:PSlovo;
    Vstup,Vystup:TextFile;
    Slov:longint;
    Nacteno,PreskocVse:boolean;
    procedure NactiSlovnik;
    procedure ZrusSlovnik;
    procedure Kontroluj(InS,OutS:string);
    function ZpracujSlovo(Co:string):string;
    function VyhodnotSlovo(Jake,Pred,Za:string):string;
    procedure VlozSlovo(Slovo:string);
    function PorovnejSlova(Slovo1,Slovo2:string):boolean;
  end;

var
  ZaklOkno: TZaklOkno;

implementation

{$R *.DFM}

procedure TZaklOkno.VlozSlovo(Slovo:string); { vlozi slovo do slovniku v pameti i na disk }
var AktS:PSlovo;
    Soubor:textFile;
begin
 AktS := Slovnik;
 while AktS.Next <> nil do AktS := AktS.Next;
 New(AktS.Next);
 AktS := AktS.Next;
 AktS.Next := nil;
 AktS.Slovo := AnsiUpperCase(Slovo);
 AssignFile(Soubor,'dict.txt');
 {$I-}
 Append(Soubor);
 if IOResult <> 0 then
 begin
  Exit;
 end;
 WriteLn(Soubor,Slovo);
 CloseFile(Soubor);
end;

function TZaklOkno.ZpracujSlovo(Co:string):string;
var Projed,PoziceL:byte;  { pri nacitani slova odstranuje parametry }
    NaselL:boolean;
    Kec:string;
begin
 PoziceL := 0; {jenom proto aby mi to nepsalo varovani }
 NaselL := false;
 for Projed := 1 to Length(Co) do
 begin
  if(Co[Projed] = '/')and(not NaselL)then
  begin
   NaselL := true;
   PoziceL := Projed;
   Break;
  end;
 end;
 Inc(Slov);
 if Slov mod 54 = 0 then  { pri kazdem 54(je to uplne jedno)slove vypise jejich pocet } 
 begin
  Str(Slov,Kec);
  KecPocet.Caption := Kec;
  KecPocet.Refresh;
 end;
 if NaselL then ZpracujSlovo := Copy(Co,1,PoziceL-1) else ZpracujSlovo := Co;
end;

procedure TZaklOkno.NactiSlovnik;  { nacita slovnik }
var Soubor:TextFile;
    Radka:string;
    AktSlovo:PSlovo;
begin
 ZaklOkno.Refresh;
 KecNacitam.Visible := true;
 KecNacitam.Refresh;
 KecPocet.Visible := true;
 KecPocet.Refresh;
 Slov := 0;
 AssignFile(Soubor,'dict.txt');
 {$I-}
 Reset(Soubor);
 if IOResult <> 0 then
 begin
  KecNacitam.Caption := 'Chyba pi otevrn souboru DICT.TXT!';
  Exit;
 end;
 New(Slovnik);
 AktSlovo := Slovnik;
 ReadLn(Soubor,Radka);
 AktSlovo.Slovo := ZpracujSlovo(Radka);
 while not EOF(Soubor) do
 begin
  ReadLn(Soubor,Radka);
  New(AktSlovo.Next);
  AktSlovo := AktSlovo.Next;
  AktSlovo.Next := nil;
  AktSlovo.Slovo := ZpracujSlovo(Radka);
 end;
 CloseFile(Soubor);
 KecNacitam.Visible := false;
 KecNacitam.Refresh;
 KecPocet.Visible := false;
 KecPocet.Refresh;
 ZaklOkno.Refresh;
 Nacteno := true;
end;

procedure TZaklOkno.ZrusSlovnik;  { odstranuje slovnik z pameti }
var Akt,Dalsi:PSlovo;
begin
 Akt := Slovnik;
 while Akt.Next <> nil do
 begin
  Dalsi := Akt.Next;
  Dispose(Akt);
  Akt := Dalsi;
 end;
 Dispose(Akt);
end;

function TZaklOkno.PorovnejSlova(Slovo1,Slovo2:string):boolean;
{   }     { porovnava slova, bohuzel pouze testovaci verze, nedodelano }
var Ruznych,Projed:byte;
begin
 PorovnejSlova := false;
 if Abs(Length(Slovo1)-Length(Slovo2))<3 then
 begin
  Ruznych := 0;
  for Projed := 1 to Length(Slovo1) do if Slovo1[Projed] <> Slovo2[Projed]then Inc(Ruznych);
  if Ruznych < 2 then PorovnejSlova := true;
 end;
end;

function TZaklOkno.VyhodnotSlovo(Jake,Pred,Za:string):string;
var AktS:PSlovo;
    Shoda:boolean;
    Slovo:string;
    Vratil:integer;
begin
 Shoda := false;
 Slovo := AnsiUpperCase(Jake);
 AktS := Slovnik;
 if Slovo = AnsiUpperCase(AktS.Slovo) then
 begin
  Shoda := true;
 end;
 if not Shoda then
 begin
  repeat
   AktS := AktS.Next;
   if Slovo = AnsiUpperCase(AktS.Slovo) then
   begin
    Shoda := true;
    Break;
   end;
  until AktS.Next = nil;
 end;
 if Shoda then VyhodnotSlovo := Jake else
 begin
  if PreskocVse then VyhodnotSlovo := Jake else
  begin
   m3802.OpravOkno.UkazRadku.Clear;
   m3802.OpravOkno.UkazRadku.Lines.Add('('+Pred+')  '+Jake+'  ('+Za+')');
   m3802.OpravOkno.ZadejOprava.Text := Jake;
   AktS := Slovnik;
   m3802.OpravOkno.SeznamNahrad.Clear;
   if PorovnejSlova(Jake,AktS.Slovo) then m3802.OpravOkno.SeznamNahrad.Items.Add(AktS.Slovo);
   while AktS.Next <> nil do
   begin
    AktS := AktS.Next;
    if PorovnejSlova(Jake,AktS.Slovo) then m3802.OpravOkno.SeznamNahrad.Items.Add(AktS.Slovo);
   end;
   Vratil := m3802.OpravOkno.ShowModal;
   case Vratil of
     mrOK:VyhodnotSlovo := m3802.OpravOkno.ZadejOprava.Text;
     mrIgnore:VyhodnotSlovo := Jake;
     mrCancel:VyhodnotSlovo := '#'+Jake;
     mrYes:begin
            VlozSlovo(Jake);
            VyhodnotSlovo := Jake;
           end;
     mrNoToAll:begin
                PreskocVse := true;
                VyhodnotSlovo := Jake;
               end;
   end;
  end;
 end;
end;

procedure TZaklOkno.Kontroluj;
var RadkaIn,RadkaOut,Slovo:string;
    Pracuj:byte;
    DelameSlovo:boolean;
begin
 PreskocVse := false;
 KecNacitam.Caption := 'Provdm kontrolu...';
 KecNacitam.Visible := true;
 KecNacitam.Refresh;
 AssignFile(Vstup,InS);
 Reset(Vstup);
 {$I-}
 if IOResult <> 0 then
 begin
  KecNacitam.Caption := 'Chyba pi otevrn souboru '+AnsiUpperCase(InS)+'!';
  Exit;
 end;
 AssignFile(Vystup,OutS);
 ReWrite(Vystup);
 {$I-}
 if IOResult <> 0 then
 begin
  KecNacitam.Caption := 'Chyba pi otevrn souboru '+AnsiUpperCase(OutS)+'!';
  CloseFile(Vstup);
  Exit;
 end;
 repeat
  ReadLn(Vstup,RadkaIn);
  RadkaOut := '';
  DelameSlovo := false;
  for Pracuj := 1 to Length(RadkaIn) do
  begin
   if(Ord(RadkaIn[Pracuj])>127)or(UpCase(RadkaIn[Pracuj]) in ['A'..'Z'])then
   begin
    if not DelameSlovo then
    begin
     Slovo := RadkaIn[Pracuj];
     DelameSlovo := true;
    end
    else Slovo := Slovo + RadkaIn[Pracuj];
   end
   else
   begin
    if DelameSlovo then
    begin
     RadkaOut := RadkaOut + VyhodnotSlovo(Slovo,RadkaOut,Copy(RadkaIn,Pracuj,Length(RadkaIn)-Pracuj+1));
     DelameSlovo := false;
    end;
    RadkaOut := RadkaOut + RadkaIn[Pracuj]
   end;
  end;
  if DelameSlovo then
  begin
   RadkaOut := RadkaOut + VyhodnotSlovo(Slovo,RadkaOut,'');
  end;
  WriteLn(Vystup,RadkaOut);
 until EOF(Vstup);
 CloseFile(Vstup);
 CloseFile(Vystup);
 KecNacitam.Caption := 'Kontrola pravopisu dokonena.';
end;

procedure TZaklOkno.TlacSpustClick(Sender: TObject);
begin
 if not Nacteno then  NactiSlovnik;
 Kontroluj(ZadejVstup.Text,ZadejVystup.Text);
end;

procedure TZaklOkno.FormActivate(Sender: TObject);
begin
 Nacteno := false;
 if ParamCount = 2 then
 begin
  ZadejVstup.Text := ParamStr(1);
  ZadejVystup.Text := ParamStr(2);
  TlacSpustClick(Sender);
 end;
end;

procedure TZaklOkno.FormDeactivate(Sender: TObject);
begin
 ZrusSlovnik;
end;

procedure TZaklOkno.TlacHledejInClick(Sender: TObject);
begin
 if OtevriSoubor.Execute then ZadejVstup.Text := OtevriSoubor.FileName;
end;

procedure TZaklOkno.TlacHledejOutClick(Sender: TObject);
begin
 if OtevriSoubor.Execute then ZadejVystup.Text := OtevriSoubor.FileName;
end;

end.
